/*
 * convert integers to/from ARM byte-sex.
 *
 * Andy Duplain, August 1992.
 */

#include "endian.h"

#ifndef LITTLEENDIAN
/*
 * convert to ARM byte-sex.
 */
unsigned armword(unsigned val)
{
  union {
    unsigned i;
    char c[4];
  } ret;

  ret.c[0] = (val >> BYTE0SHIFT) & 0xff;
  ret.c[1] = (val >> BYTE1SHIFT) & 0xff;
  ret.c[2] = (val >> BYTE2SHIFT) & 0xff;
  ret.c[3] = (val >> BYTE3SHIFT) & 0xff;
  return (ret.i);
}

/*
 * convert from ARM byte-sex.
 */
unsigned ourword(unsigned val)
{
  union {
    unsigned i;
    char c[4];
  } ret;

  ret.c[0] = (val >> BYTE0SHIFT) & 0xff;
  ret.c[1] = (val >> BYTE1SHIFT) & 0xff;
  ret.c[2] = (val >> BYTE2SHIFT) & 0xff;
  ret.c[3] = (val >> BYTE3SHIFT) & 0xff;
  return (ret.i);
}

#endif /*LITTLEENDIAN*/
