/*
 *  input.h
 * Copyright  1992 Niklas Rjemo
 */

#ifndef _input_h
#define _input_h

#ifndef _global_h
#include "global.h"
#endif

#ifndef _macros_h
#include "macros.h"
#endif


extern BOOL inputExpand;
extern BOOL inputRewind;
extern char* inputName;

void inputInit(char *infile);
void inputFinish(void);

BOOL inputNextLine(void);

void skipblanks(void);
void skiprest(void);

extern long int inputLineNo;  /* Do not change, only read! */

int  inputComment(void); /* True if null or a comment */
char inputLook(void);
char inputLookLower(void);
char inputLookUC(void);
char inputLookN(int n);
char inputLookNLower(int n);
char inputLookNUC(int n);
char inputGet(void);
char inputGetLower(void);
char inputGetUC(void);
void inputUnGet(char c);
char inputSkipLook(void);
char *inputRest(void);
char *inputLine(void);
void inputSkip(void);
void inputSkipN(int n);
char *inputSymbol(int *ilen, char del);

void inputMark(void);
void inputRollback(void);

void inputThisInstead(char*);

#endif
