/*
 * riscos.c
 * Copyright  1992 Niklas Rjemo
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "error.h"
#include "riscos.h"
#if defined(UNIXLIB) && defined(__riscos)
#include <unixlib/local.h>
#else
#include "uname.h"
#endif

char *toriscos(char *name, char *oldsuffixes, char newsuffix)
{
  char *suf,*last;

  if((suf = strrchr(name,'.')) == 0) {
    if(newsuffix != 'o')
      error(ErrorError,TRUE,"Missing suffix/prefix in %s",name);
  } else if(strchr(oldsuffixes,suf[1]) != 0 && suf[2] == 0) { /* Unix style name.[so] */
    last = strrchr(name,0); /* End of file name */
    while(--suf >= name && *suf != '.')
      *--last = *suf;
    suf[1] = newsuffix;
    suf[2] = '.';
  } else if(suf > name && strchr(oldsuffixes,suf[-1]) != 0 && (suf == name+1 || suf[-2] == '.')) {
        suf[-1] = newsuffix;     /* RISC/OS style name s.name */
  } /* else
    if(newsuffix != 'o')
      error(ErrorWarning,TRUE,"File %s is not an assembler file (s.name or name.s)",name);
    */

  return name;
}

static char filename[1024];
extern int dde;

char *CanonicalisePath(const char *path)
{
  int size;
  char *buffer;
#ifdef UNIXLIB
  path=__uname(path,0);
#else
  path=uname(path,dde);
#endif
  if(dde && *path == '@') { /* Replace @ with <Prefix$Dir> if dde flags */
    /*strcpy(filename,"<Prefix$Dir>");*/
    strcat(filename,path+2/*was 1*/);
  } else {
    strcpy(filename,path);
  }
#ifdef __riscos
  size = 1-OSCanonicalisePath(filename,0,0,0,0);
#else
  size = strlen(filename);
#endif
  buffer = malloc(size);
  if (buffer) {
    size = OSCanonicalisePath(filename,buffer,size,0,0);
    if (size == 1) return buffer;
  }

  error(ErrorAbort,TRUE,"Internal error in CanonicalisePath");
  exit(-1);
  return 0; /* keep the compiler happy */
}

